<?php
/* ======================================================
 # Support Hours for Joomla! - v1.6.2 (free version)
 # -------------------------------------------------------
 # For Joomla! CMS (v3.x)
 # Author: Web357 (Yiannis Christodoulou)
 # Copyright (©) 2014-2023 Web357. All rights reserved.
 # License: GNU/GPLv3, http://www.gnu.org/licenses/gpl-3.0.html
 # Website: https:/www.web357.com
 # Demo: https://demo.web357.com/joomla/browse/support-hours
 # Support: support@web357.com
 # Last modified: Monday 10 July 2023, 03:51:28 AM
 ========================================================= */
defined('JPATH_BASE') or die;

jimport('joomla.form.formfield');
jimport( 'joomla.form.form' );

class JFormFieldsupporthours extends JFormField {
	
	protected $type = 'supporthours';
	
	protected function getLabel()
	{		
		$day = $this->element["class"];
		$labels_html  = '';
		$labels_html .= ($day == 'Default') ? '<div class="label_day" style="margin-top:20px;"><label id="jform_params_'.$day.'CustomHours-lbl" for="jform_params_'.$day.'CustomHours" class="hasTooltip" title="&lt;strong&gt;'.JText::_($this->hint).'&lt;/strong&gt;&lt;br /&gt;'.JText::_('MOD_SUPPORTHOURS_DEFAULT_OPEN_HOURS_DESC').'">'.JText::_($this->hint).'</label></div>' : '';
		
		return $labels_html;
	}

	protected function getInput() 
	{
		// get the values after save
		$day = $this->element["class"];
		$values = (!empty($this->value)) ? call_user_func_array('array_merge', $this->value) : array();

		// print
		$html = '';
		
		// js
		$javascript = '
		jQuery(document).ready(function (val) {'."\n";
		
		// links
		$links_arr = array("available_left_link", "available_right_link", "offline_left_link", "offline_right_link");
		
		foreach ($links_arr as $v):
		$javascript .= '
			function toggleShow'.$v.'(val) {
				var controls = [\'jform[params]['.$v.'_txt]\'];
				var checked = jQuery(\'input[name="jform[params][show_'.$v.']"]:radio:checked\').first();
				if (checked) {
					val = checked.val();
				}
				jQuery.each(controls, function () {
					jQuery(\'[name="\' + this + \'"]\').each(function () {
						var group1 = jQuery(this).closest(\'.control-group\');
						var group2 = jQuery(this).closest(\'.control-group\').next(\'.control-group\');
						var group3 = jQuery(this).closest(\'.control-group\').next(\'.control-group\').next(\'.control-group\');
						if (group1 && group2 && group3) {
							if (val == 1) {
								group1.show();
								group2.show();
								group3.show();
							} else {
								group1.hide();
								group2.hide();
								group3.hide();
							}
						}
					});
				});
			}
			jQuery(\'input[name="jform[params][show_'.$v.']"]:radio\').click(function () {
				toggleShow'.$v.'(jQuery(this).val());
			});		
			toggleShow'.$v.'();'."\n";
		endforeach;
		
		// open days and support hours
		$javascript .= ($day != 'Default') ? '
			function toggleDayStatus(val) {
				var controls = [\'jform[params]['.$day.'_custom]\'];
				var checked = jQuery(\'input[name="jform[params]['.$day.'_status]"]:radio:checked\').first();
				if (checked) {
					val = checked.val();
				}
				jQuery.each(controls, function () {
					jQuery(\'[name="\' + this + \'"]\').each(function () {
						var group = jQuery(this).closest(\'.control-group\');
						if (group) {
							if (val == 1) {
								group.show();
								jQuery(\'#support_hours_'.$day.'\').show();
							} else {
								group.hide();
								jQuery(\'#support_hours_'.$day.'\').hide();
								jQuery("#'.$day.'_open_hour12").prop("disabled", "disabled");
								jQuery("#'.$day.'_open_hour24").prop("disabled", "disabled");
								jQuery("#'.$day.'_open_min").prop("disabled", "disabled");
								jQuery("#'.$day.'_close_hour12").prop("disabled", "disabled");
								jQuery("#'.$day.'_close_hour24").prop("disabled", "disabled");
								jQuery("#'.$day.'_close_min").prop("disabled", "disabled");
								jQuery("#'.$day.'_open_ampm").prop("disabled", "disabled");
								jQuery("#'.$day.'_close_ampm").prop("disabled", "disabled");
							}
						}

					});
				});
			}
			jQuery(\'input[name="jform[params]['.$day.'_status]"]:radio\').click(function () {
				toggleDayStatus(jQuery(this).val());
			});		
			toggleDayStatus();' : '';

		$javascript .= ($day != 'Default') ? '
			function toggleDayCustomHours(val) {
				var controls = [\'jform[params]['.$day.'CustomHours][]['.$day.'_open_hour]\'];
				var checked = jQuery(\'input[name="jform[params]['.$day.'_custom]"]:radio:checked\').first();
				if (checked) {
					val = checked.val();
				}
				jQuery.each(controls, function () {
					jQuery(\'[name="\' + this + \'"]\').each(function () {
						var group = jQuery(this).closest(\'.control-group\');
						if (group) {
							if (val == "custom") {
								group.show();
							} else {
								group.hide();
							}
						}
					});
				});
			}
			jQuery(\'input[name="jform[params]['.$day.'_custom]"]:radio\').click(function () {
				toggleDayCustomHours(jQuery(this).val());
			});
			toggleDayCustomHours();' : '';
			
		$javascript .= '});';
		$document = JFactory::getDocument();
		//$document->addScriptDeclaration($javascript);

		// css
		$html .= '<style type="text/css">
					#support_hours_'.$day.' select { 
						width: 60px; 
						margin-right: 5px !important; 
						padding-right: 5px !important;
					}
					#support_hours_'.$day.' .chzn-container {
						margin-right: 10px;
					}
					#support_hours_'.$day.' #support_hours_open,
					#support_hours_'.$day.' #support_hours_close {
						display: inline-block;
					}
					#support_hours_'.$day.' #support_hours_close {
						margin-left: 30px;
					}
					#support_hours_'.$day.' input {
						position: relative;
   						top: -2px;
					}
					#support_hours_'.$day.' .select_am_pm,
					#support_hours_'.$day.' .open12,
					#support_hours_'.$day.' .open24,
					#support_hours_'.$day.' .close12,
					#support_hours_'.$day.' .close24 {
						display: inline-block;
					}
				  </style>';

		$html .= '<div id="support_hours_'.$day.'">';

			// BEGIN: OPEN
			$html .= '<div id="support_hours_open">';

			// Set values
			$values_day_open_hour = isset($values[$day.'_open_hour']) ? $values[$day.'_open_hour'] : '09';
			$values_day_open_min = isset($values[$day.'_open_min']) ? $values[$day.'_open_min'] : '00';
			$values_day_close_hour = isset($values[$day.'_close_hour']) ? $values[$day.'_close_hour'] : '05';
			$values_day_close_min = isset($values[$day.'_close_min']) ? $values[$day.'_close_min'] : '00';

			// 12 hours system
			$html .= '<label>'.JText::_($this->hint == 'AfterBreak' ? 'MOD_SUPPORTHOURS_OPEN_AFTER_BREAK_LBL' : 'MOD_SUPPORTHOURS_OPEN_LBL').'</label>';
			$html .= '<div class="open12">';
			$html .= '<select id="'.$day.'_open_hour12" name="'.$this->name.'['.$day.'_open_hour]">';
			$html .= '<option value="HH" value="HH"'.(($values_day_open_hour == 'HH') ? ' selected="selected"' : '').'>HH</option>';
			for ($i=1;$i<=12;$i++):
				$v = (($i<10) ? '0'.$i : $i);
				$html .= '<option value="'.$v.'"'.(($values_day_open_hour == $v) ? ' selected="selected"' : '').'>'.$v.'</option>';
			endfor;
			$html .= '</select>';
			$html .= '</div>';

			// minutes
			$html .= '<select id="'.$day.'_open_min" name="'.$this->name.'['.$day.'_open_min]">';
			$html .= '<option value="MM" value="MM"'.(($values_day_open_min == 'MM') ? ' selected="selected"' : '').'>MM</option>';
			for ($i=0;$i<=59;$i++):
				$v = (($i<10) ? '0'.$i : $i);
				$html .= '<option value="'.$v.'"'.(($values_day_open_min == $v) ? ' selected="selected"' : '').'>'.$v.'</option>';
			endfor;
			$html .= '</select>';

			// am/pm
			$html .= '<div class="select_am_pm">';
			$html .= '<select id="'.$day.'_open_ampm" name="'.$this->name.'['.$day.'_open_ampm]">';
				$open_ampm = !isset($values[$day.'_open_ampm']) ? 'AM' : $values[$day.'_open_ampm'];
				$html .= '<option value="AM"'.(($open_ampm == 'AM') ? ' selected="selected"' : '').'>'.JText::_('MOD_SUPPORTHOURS_AM_VALUE').'</option>';
				$html .= '<option value="PM"'.(($open_ampm == 'PM') ? ' selected="selected"' : '').'>'.JText::_('MOD_SUPPORTHOURS_PM_VALUE').'</option>';
			$html .= '</select>';
			$html .= '</div>';

			$html .= '</div>';
			// END: OPEN

			// BEGIN: CLOSE
			$html .= '<div id="support_hours_close">';

			// 12 hours system
			$html .= '<label>'.JText::_($this->hint == 'AfterBreak' ? 'MOD_SUPPORTHOURS_CLOSE_AFTER_BREAK_LBL' : 'MOD_SUPPORTHOURS_CLOSE_LBL').'</label>';
			$html .= '<div class="close12">';
			$html .= '<select id="'.$day.'_close_hour12" name="'.$this->name.'['.$day.'_close_hour]">';
			$html .= '<option value="HH" value="HH"'.(($values_day_close_hour == 'HH') ? ' selected="selected"' : '').'>HH</option>';
			for ($i=1;$i<=12;$i++):
				$v = (($i<10) ? '0'.$i : $i);
				$html .= '<option value="'.$v.'"'.(($values_day_close_hour == $v) ? ' selected="selected"' : '').'>'.$v.'</option>';
			endfor;
			$html .= '</select>';
			$html .= '</div>';

			// minutes
			$html .= '<select id="'.$day.'_close_min" name="'.$this->name.'['.$day.'_close_min]">';
			$html .= '<option value="MM" value="MM"'.(($values_day_close_min == 'MM') ? ' selected="selected"' : '').'>MM</option>';
			for ($i=0;$i<=59;$i++):
				$v = (($i<10) ? '0'.$i : $i);
				$html .= '<option value="'.$v.'"'.(($values_day_close_min == $v) ? ' selected="selected"' : '').'>'.$v.'</option>';
			endfor;
			$html .= '</select>';

			// am/pm
			$html .= '<div class="select_am_pm">';
			$html .= '<select id="'.$day.'_close_ampm" name="'.$this->name.'['.$day.'_close_ampm]">';
				$close_ampm = !isset($values[$day.'_close_ampm']) ? 'PM' : $values[$day.'_close_ampm'];
				$html .= '<option value="AM"'.(($close_ampm == 'AM') ? ' selected="selected"' : '').'>'.JText::_('MOD_SUPPORTHOURS_AM_VALUE').'</option>';
				$html .= '<option value="PM"'.(($close_ampm == 'PM') ? ' selected="selected"' : '').'>'.JText::_('MOD_SUPPORTHOURS_PM_VALUE').'</option>';
			$html .= '</select>';
			$html .= '</div>';

			$html .= '</div>';
			// END: CLOSE

		$html .= '</div>';
		
		return $html;
	}
	
}