<?php
/* ======================================================
 # Support Hours for Joomla! - v1.6.2 (free version)
 # -------------------------------------------------------
 # For Joomla! CMS (v3.x)
 # Author: Web357 (Yiannis Christodoulou)
 # Copyright (©) 2014-2023 Web357. All rights reserved.
 # License: GNU/GPLv3, http://www.gnu.org/licenses/gpl-3.0.html
 # Website: https:/www.web357.com
 # Demo: https://demo.web357.com/joomla/browse/support-hours
 # Support: support@web357.com
 # Last modified: Monday 10 July 2023, 03:51:28 AM
 ========================================================= */
defined('_JEXEC') or die;

// get helper
require_once(dirname(__FILE__).'/helper.php');
$modSupportHoursHelper = new modSupportHoursHelper();

// Default Vars
jimport('joomla.environment.uri' );
$host = JURI::root();
$document = JFactory::getDocument();

// Get Joomla Language File Name
$lg = JFactory::getLanguage();
$language = $lg->get('tag');

// Convert an Object to array
if(!function_exists('ObjectToArray')):
function ObjectToArray($obj) 
{
	if(!is_array($obj) && !is_object($obj)) return $obj;
	if(is_object($obj)) $obj = get_object_vars($obj);
	return array_map('ObjectToArray', $obj);
}
endif;

// Get Absolute path of Joomla
$absolute_path = getcwd();
$months = 
		array(
			JText::_('JANUARY'), 
			JText::_('FEBRUARY'), 
			JText::_('MARCH'), 
			JText::_('APRIL'), 
			JText::_('MAY'), 
			JText::_('JUNE'), 
			JText::_('JULY'), 
			JText::_('AUGUST'), 
			JText::_('SEPTEMBER'),
			JText::_('OCTOBER'), 
			JText::_('NOVEMBER'), 
			JText::_('DECEMBER')
		); 
$days = 
	array( 
		JText::_('SUNDAY'),
		JText::_('MONDAY'), 
		JText::_('TUESDAY'), 
		JText::_('WEDNESDAY'), 
		JText::_('THURSDAY'), 
		JText::_('FRIDAY'), 
		JText::_('SATURDAY')
		);
$server_now = time();

// ===================== BEGIN: Get Module Parameters ===================== 
// Module
$layout_param = $params->get('layout', 'layout-1');
$layout = ($layout_param == '_:default') ? 'layout-1' : $layout_param;
$box_width = $params->get('box_width', '320px');
$office_img = $params->get('office_img', 'modules/mod_supporthours/tmpl/icons/office_img.png');

// Links
/* available left link */
$show_available_left_link = $params->get('show_available_left_link', '1');
$available_left_link_txt = $params->get('available_left_link_txt', 'Contact us');
$available_left_link_url = $params->get('available_left_link_url', '#');
$available_left_link_target = $params->get('available_left_link_target', '_self');

/* available right link */
$show_available_right_link = $params->get('show_available_right_link', '1');
$available_right_link_txt = $params->get('available_right_link_txt', 'Live chat');
$available_right_link_url = $params->get('available_right_link_url', '#');
$available_right_link_target = $params->get('available_right_link_target', '_self');

/* offline left link */
$show_offline_left_link = $params->get('show_offline_left_link', '1');
$offline_left_link_txt = $params->get('offline_left_link_txt', 'Send Email');
$offline_left_link_url = $params->get('offline_left_link_url', '#');
$offline_left_link_target = $params->get('offline_left_link_target', '_self');

/* offline right link */
$show_offline_right_link = $params->get('show_offline_right_link', '0');
$offline_right_link_txt = $params->get('offline_right_link_txt', '');
$offline_right_link_url = $params->get('offline_right_link_url', '#');
$offline_right_link_target = $params->get('offline_right_link_target', '_self');

// Timezone Settings
$offset_param = $params->get('offset', '');

// Date and Time Settings

/* date */
$dateformat = $params->get('dateformat', '');
$custom_date_format = $params->get('custom_date_format', '');
$dateformat = (!empty($custom_date_format)) ? $custom_date_format : $dateformat;

/* time */
$timeformat = $params->get('timeformat', '3');
$hour_system = (int)$params->get('hour_system', '12');
$display_pm_am = (int)$params->get('display_pm_am', '1');
$between_text_param = ', ';
$between_text = (!empty($between_text_param) && !empty($dateformat) && $timeformat != 4) ? $between_text_param.' ' : ''; // the text between date and time
$display_gmt = (int)$params->get('display_gmt', '1');
$display_open_hours_beside_maintext = (int)$params->get('display_open_hours_beside_maintext', '1');

// Support Days and Hours
$default_break = $params->get('break', '0');

/* Day_status */
$days_status_arr = array();
$days_status_arr['Monday_status'] = $params->get('Monday_status', '1');
$days_status_arr['Tuesday_status'] = $params->get('Tuesday_status', '1');
$days_status_arr['Wednesday_status'] = $params->get('Wednesday_status', '1');
$days_status_arr['Thursday_status'] = $params->get('Thursday_status', '1');
$days_status_arr['Friday_status'] = $params->get('Friday_status', '1');
$days_status_arr['Saturday_status'] = $params->get('Saturday_status', '0');
$days_status_arr['Sunday_status'] = $params->get('Sunday_status', '0');

/* Day_break */
$days_break_arr = array();
$days_break_arr['Monday_break'] = $params->get('Monday_break', '0');
$days_break_arr['Tuesday_break'] = $params->get('Tuesday_break', '0');
$days_break_arr['Wednesday_break'] = $params->get('Wednesday_break', '0');
$days_break_arr['Thursday_break'] = $params->get('Thursday_break', '0');
$days_break_arr['Friday_break'] = $params->get('Friday_break', '0');
$days_break_arr['Saturday_break'] = $params->get('Saturday_break', '0');
$days_break_arr['Sunday_break'] = $params->get('Sunday_break', '0');

/* Day_custom */
$days_custom_arr = array();
$days_custom_arr['Monday_custom'] = $params->get('Monday_custom', '');
$days_custom_arr['Tuesday_custom'] = $params->get('Tuesday_custom', '');
$days_custom_arr['Wednesday_custom'] = $params->get('Wednesday_custom', '');
$days_custom_arr['Thursday_custom'] = $params->get('Thursday_custom', '');
$days_custom_arr['Friday_custom'] = $params->get('Friday_custom', '');
$days_custom_arr['Saturday_custom'] = $params->get('Saturday_custom', '');
$days_custom_arr['Sunday_custom'] = $params->get('Sunday_custom', '');

/* DayCustomHours */
$DefaultCustomHours 			= $params->get('DefaultCustomHours');
$MondayCustomHours 				= $params->get('MondayCustomHours');
$TuesdayCustomHours 			= $params->get('TuesdayCustomHours');
$WednesdayCustomHours 			= $params->get('WednesdayCustomHours');
$ThursdayCustomHours 			= $params->get('ThursdayCustomHours');
$FridayCustomHours 				= $params->get('FridayCustomHours');
$SaturdayCustomHours 			= $params->get('SaturdayCustomHours');
$SundayCustomHours 				= $params->get('SundayCustomHours');
$DefaultCustomHours 			= (!empty($DefaultCustomHours) && is_array($DefaultCustomHours)) ? call_user_func_array('array_merge', ObjectToArray($DefaultCustomHours)) : array();
$MondayCustomHours 				= (!empty($MondayCustomHours) && is_array($MondayCustomHours) && $days_custom_arr['Monday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($MondayCustomHours)) : array();
$TuesdayCustomHours 			= (!empty($TuesdayCustomHours) && is_array($TuesdayCustomHours) && $days_custom_arr['Tuesday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($TuesdayCustomHours)) : array();
$WednesdayCustomHours 			= (!empty($WednesdayCustomHours) && is_array($WednesdayCustomHours) && $days_custom_arr['Wednesday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($WednesdayCustomHours)) : array();
$ThursdayCustomHours 			= (!empty($ThursdayCustomHours) && is_array($ThursdayCustomHours) && $days_custom_arr['Thursday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($ThursdayCustomHours)) : array();
$FridayCustomHours 				= (!empty($FridayCustomHours) && is_array($FridayCustomHours) && $days_custom_arr['Friday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($FridayCustomHours)) : array();
$SaturdayCustomHours 			= (!empty($SaturdayCustomHours) && is_array($SaturdayCustomHours) && $days_custom_arr['Saturday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($SaturdayCustomHours)) : array();
$SundayCustomHours 				= (!empty($SundayCustomHours) && is_array($SundayCustomHours) && $days_custom_arr['Sunday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($SundayCustomHours)) : array();
$supporthours_arr 				= array_merge($days_status_arr, $days_break_arr, $days_custom_arr, $DefaultCustomHours, $MondayCustomHours, $TuesdayCustomHours, $WednesdayCustomHours, $ThursdayCustomHours, $FridayCustomHours, $SaturdayCustomHours, $SundayCustomHours);

/* DayCustomHours (after break) */
$DefaultCustomHoursAfterBreak 	= $params->get('DefaultCustomHoursAfterBreak');
$MondayCustomHoursAfterBreak 	= $params->get('MondayCustomHoursAfterBreak');
$TuesdayCustomHoursAfterBreak 	= $params->get('TuesdayCustomHoursAfterBreak');
$WednesdayCustomHoursAfterBreak = $params->get('WednesdayCustomHoursAfterBreak');
$ThursdayCustomHoursAfterBreak 	= $params->get('ThursdayCustomHoursAfterBreak');
$FridayCustomHoursAfterBreak 	= $params->get('FridayCustomHoursAfterBreak');
$SaturdayCustomHoursAfterBreak 	= $params->get('SaturdayCustomHoursAfterBreak');
$SundayCustomHoursAfterBreak 	= $params->get('SundayCustomHoursAfterBreak');

$DefaultCustomHoursAfterBreak 	= (!empty($DefaultCustomHoursAfterBreak) && is_array($DefaultCustomHoursAfterBreak)) ? call_user_func_array('array_merge', ObjectToArray($DefaultCustomHoursAfterBreak)) : array();
$MondayCustomHoursAfterBreak 	= (!empty($MondayCustomHoursAfterBreak) && is_array($MondayCustomHoursAfterBreak) && $days_custom_arr['Monday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($MondayCustomHoursAfterBreak)) : array();
$TuesdayCustomHoursAfterBreak 	= (!empty($TuesdayCustomHoursAfterBreak) && is_array($TuesdayCustomHoursAfterBreak) && $days_custom_arr['Tuesday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($TuesdayCustomHoursAfterBreak)) : array();
$WednesdayCustomHoursAfterBreak = (!empty($WednesdayCustomHoursAfterBreak) && is_array($WednesdayCustomHoursAfterBreak) && $days_custom_arr['Wednesday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($WednesdayCustomHoursAfterBreak)) : array();
$ThursdayCustomHoursAfterBreak 	= (!empty($ThursdayCustomHoursAfterBreak) && is_array($ThursdayCustomHoursAfterBreak) && $days_custom_arr['Thursday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($ThursdayCustomHoursAfterBreak)) : array();
$FridayCustomHoursAfterBreak 	= (!empty($FridayCustomHoursAfterBreak) && is_array($FridayCustomHoursAfterBreak) && $days_custom_arr['Friday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($FridayCustomHoursAfterBreak)) : array();
$SaturdayCustomHoursAfterBreak 	= (!empty($SaturdayCustomHoursAfterBreak) && is_array($SaturdayCustomHoursAfterBreak) && $days_custom_arr['Saturday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($SaturdayCustomHoursAfterBreak)) : array();
$SundayCustomHoursAfterBreak 	= (!empty($SundayCustomHoursAfterBreak) && is_array($SundayCustomHoursAfterBreak) && $days_custom_arr['Sunday_custom'] == 'custom') ? call_user_func_array('array_merge', ObjectToArray($SundayCustomHoursAfterBreak)) : array();
$supporthours_arr_after_break	= array_merge($days_status_arr, $days_break_arr, $days_custom_arr, $DefaultCustomHoursAfterBreak, $MondayCustomHoursAfterBreak, $TuesdayCustomHoursAfterBreak, $WednesdayCustomHoursAfterBreak, $ThursdayCustomHoursAfterBreak, $FridayCustomHoursAfterBreak, $SaturdayCustomHoursAfterBreak, $SundayCustomHoursAfterBreak);

// Texts
/* state */
$state_text = $params->get('state_text', '');

/* available */
$online_text = $params->get('online_text', 'Online');
$front_text_available = $params->get('front_text_available', 'Monday - Friday');
$open_hours_time_format = $params->get('open_hours_time_format', 'only_hours_with_pmam');

/* offline */
$offline_text = $params->get('offline_text', 'Offline');
$front_text_offline = $params->get('front_text_offline', 'Monday - Friday');

// BEGIN: Texts for custom days
// Monday
$monday_online_text = $params->get('monday_online_text', $online_text);
$monday_front_text_available = $params->get('monday_front_text_available', $front_text_available);
$monday_offline_text = $params->get('monday_offline_text', $offline_text);
$monday_front_text_offline = $params->get('monday_front_text_offline', $front_text_offline);

// Tuesday
$tuesday_online_text = $params->get('tuesday_online_text', $online_text);
$tuesday_front_text_available = $params->get('tuesday_front_text_available', $front_text_available);
$tuesday_offline_text = $params->get('tuesday_offline_text', $offline_text);
$tuesday_front_text_offline = $params->get('tuesday_front_text_offline', $front_text_offline);

// Wednesday
$wednesday_online_text = $params->get('wednesday_online_text', $online_text);
$wednesday_front_text_available = $params->get('wednesday_front_text_available', $front_text_available);
$wednesday_offline_text = $params->get('wednesday_offline_text', $offline_text);
$wednesday_front_text_offline = $params->get('wednesday_front_text_offline', $front_text_offline);

// Thursday
$thursday_online_text = $params->get('thursday_online_text', $online_text);
$thursday_front_text_available = $params->get('thursday_front_text_available', $front_text_available);
$thursday_offline_text = $params->get('thursday_offline_text', $offline_text);
$thursday_front_text_offline = $params->get('thursday_front_text_offline', $front_text_offline);

// Friday
$friday_online_text = $params->get('friday_online_text', $online_text);
$friday_front_text_available = $params->get('friday_front_text_available', $front_text_available);
$friday_offline_text = $params->get('friday_offline_text', $offline_text);
$friday_front_text_offline = $params->get('friday_front_text_offline', $front_text_offline);

// Saturday
$saturday_online_text = $params->get('saturday_online_text', $online_text);
$saturday_front_text_available = $params->get('saturday_front_text_available', $front_text_available);
$saturday_offline_text = $params->get('saturday_offline_text', $offline_text);
$saturday_front_text_offline = $params->get('saturday_front_text_offline', $front_text_offline);

// Sunday
$sunday_online_text = $params->get('sunday_online_text', $online_text);
$sunday_front_text_available = $params->get('sunday_front_text_available', $front_text_available);
$sunday_offline_text = $params->get('sunday_offline_text', $offline_text);
$sunday_front_text_offline = $params->get('sunday_front_text_offline', $front_text_offline);
// ENDS: Texts for custom days

// Holidays
$holidays = $params->get('holidays', '');

// Styling

/* button (If support is Available) */
$available_btn_background_color = $params->get('available_btn_background_color', '#3DAB7C');
$available_btn_text_color = $params->get('available_btn_text_color', '#fff');
$available_btn_border_radius = $params->get('available_btn_border_radius', '4px');

/* button (If support is Offline) */
$offline_btn_background_color = $params->get('offline_btn_background_color', '#d9534f');
$offline_btn_text_color = $params->get('offline_btn_text_color', '#fff');
$offline_btn_border_radius = $params->get('offline_btn_border_radius', '4px');

/* other */
$space_between_times_param = $params->get('space_between_times', '20px');
$space_between_times = (!empty($space_between_times_param)) ? 'style="margin-left: '.$space_between_times_param.';"' : 'style="margin-left: 20px;"';
 
/* custom css */
$custom_css_param = $params->get('custom_css', '');

// Footer
$display_copyright = $params->get('display_copyright', '1');

// ===================== END: Get Module Parameters ===================== 

// Offset
$config = JFactory::getConfig();
if (!empty($offset_param)):
	$offset = $offset_param;
elseif(version_compare(JVERSION,'1.6.0') < 0):
	$offset = $config->getValue('config.offset'); //j16+
else:
	$offset = $config->get('offset'); //j30+
endif;
$timezone = new DateTime('', new DateTimeZone($offset)); // example: -18000, -14400 (http://www.php.net/manual/en/datetime.getoffset.php)
$get_offset = $timezone->getOffset();
$tzoffset = $get_offset / 3600; // example: -4, -4
$our_gmt = ($tzoffset >= 0) ? '+'.$tzoffset : $tzoffset ; // e.g. -2, +4, +8, +10.5
$local_now = (strpos($our_gmt, '.5') !== false) ? strtotime(str_replace('.5', '', $tzoffset).' hours + 30minutes') : strtotime($tzoffset.' hours');
$offset_txt = str_replace('_', ' ', $offset); // e.g. (America/New York);

// BEGIN: Calculate Our time
$day_of_the_week = gmdate("w", $local_now); // day (Monday)
$day = gmdate("j", $local_now);  // day (7)
$month_full = gmdate("F", $local_now); // month (March)
$full_month = JText::_(strtoupper($month_full)); // month (Mar) from .ini
$short_month = JText::_(strtoupper($month_full).'_SHORT'); // month (Mar) from .ini
$month = gmdate("n", $local_now); // month (3)
$year = gmdate("Y", $local_now); // year (2014)
$d = gmdate("d", $local_now); // day (07)
$l = gmdate("l", $local_now); // day (Monday)
$m = gmdate("m", $local_now); // month (03)
$Y = gmdate("Y", $local_now); // year (2015)
$h = ($hour_system == '12') ? gmdate("g", $local_now) : gmdate("G", $local_now); // (h: 07)( H: 19)
$i = gmdate("i", $local_now); // minute (38)
$s = gmdate("s", $local_now); // second (06)
$a = gmdate("a", $local_now); // PM/AM
// END: Calculate Our time

// BEGIN: Calculate Your time
$your_day_of_the_week = JHtml::date('now','w'); // day (Monday)
$your_day = JHtml::date('now','j');  // day (7)
$your_month_full = JHtml::date('now','F'); // month (March)
$your_full_month = JText::_(strtoupper($your_month_full)); // month (Mar) from .ini
$your_short_month = JText::_(strtoupper($your_month_full).'_SHORT'); // month (Mar) from .ini
$your_month = JHtml::date('now','n'); // month (3)
$your_year = JHtml::date('now','Y'); // year (2014)
$your_d = JHtml::date('now','d'); // day (07)
$your_m = JHtml::date('now','m'); // month (03)
$your_Y = JHtml::date('now','Y'); // year (2015)
$your_h = ($hour_system == '12') ? JHtml::date('now','h') : JHtml::date('now','h'); // (h: 07)( H: 19)
$your_i = JHtml::date('now','i'); // minute (38)
$your_s = JHtml::date('now','s'); // second (06)
$your_a = JHtml::date('now','A'); // PM/AM
// END: Calculate Your time

// BEGIN: Build Our and Your time
$your_date = $modSupportHoursHelper->getDate($your_Y, $your_m, $your_d, $dateformat, $days, $your_day_of_the_week, $your_day, $months, $your_month, $your_short_month, $your_full_month, $your_year);
$your_time = $modSupportHoursHelper->getTime("visitor_time_display", $timeformat, $display_pm_am, $hour_system, 0, $your_h, $your_i, $your_a, $module);
$our_date = $modSupportHoursHelper->getDate($Y, $m, $d, $dateformat, $days, $day_of_the_week, $day, $months, $month, $short_month, $full_month, $year);
$our_date_value = $modSupportHoursHelper->getDate($Y, $m, $d, $dateformat, $days, $day_of_the_week, $day, $months, $month, $short_month, $full_month, $year, 'value');
$our_time = $modSupportHoursHelper->getTime("our_time", $timeformat, $display_pm_am, $hour_system, $offset, $h, $i, $a, $module);
$our_time_static = $modSupportHoursHelper->getTime("our_time_static", $timeformat, $display_pm_am, $hour_system, $offset, $h, $i, $a, $module);
$visitor_time_static = $modSupportHoursHelper->getTime("visitor_time_static", $timeformat, $display_pm_am, $hour_system, 0, $your_h, $your_i, $your_a, $module);
// END: Build Our and Your time

// BEGIN: Open Hours
// get default values from array

// before break
$default_open_hour = isset($supporthours_arr['Default_open_hour']) ? $supporthours_arr['Default_open_hour'] : '00';
$default_open_min = isset($supporthours_arr['Default_open_min']) ? $supporthours_arr['Default_open_min'] : '00';
$default_open_ampm = isset($supporthours_arr['Default_open_ampm']) ? $supporthours_arr['Default_open_ampm'] : '';
$default_close_hour = isset($supporthours_arr['Default_close_hour']) ? $supporthours_arr['Default_close_hour'] : '23';
$default_close_min = isset($supporthours_arr['Default_close_min']) ? $supporthours_arr['Default_close_min'] : '59';
$default_close_ampm = isset($supporthours_arr['Default_close_ampm']) ? $supporthours_arr['Default_close_ampm'] : '';

// after break
$default_open_hour_after_break = isset($supporthours_arr_after_break['Default_open_hour']) ? $supporthours_arr_after_break['Default_open_hour'] : '00';
$default_open_min_after_break = isset($supporthours_arr_after_break['Default_open_min']) ? $supporthours_arr_after_break['Default_open_min'] : '00';
$default_open_ampm_after_break = isset($supporthours_arr_after_break['Default_open_ampm']) ? $supporthours_arr_after_break['Default_open_ampm'] : '';
$default_close_hour_after_break = isset($supporthours_arr_after_break['Default_close_hour']) ? $supporthours_arr_after_break['Default_close_hour'] : '23';
$default_close_min_after_break = isset($supporthours_arr_after_break['Default_close_min']) ? $supporthours_arr_after_break['Default_close_min'] : '59';
$default_close_ampm_after_break = isset($supporthours_arr_after_break['Default_close_ampm']) ? $supporthours_arr_after_break['Default_close_ampm'] : '';

// get values from array
$day_status = ($supporthours_arr[$l.'_status']) ? $supporthours_arr[$l.'_status'] : 0;
$day_break = ($supporthours_arr[$l.'_custom'] == 'custom') ? $supporthours_arr[$l.'_break'] : $default_break;

// Is an active day?
if ($day_status):
	$active_day = 'on';
else:
	$active_day = 'off';
endif;

// before break (default)
$day_open_hour 	= isset($supporthours_arr[$l.'_open_hour']) ? $supporthours_arr[$l.'_open_hour'] : 'HH';
$day_open_min 	= isset($supporthours_arr[$l.'_open_min']) ? $supporthours_arr[$l.'_open_min'] : 'MM';
$day_open_ampm 	= isset($supporthours_arr[$l.'_open_ampm']) ? $supporthours_arr[$l.'_open_ampm'] : '';
$day_close_hour = isset($supporthours_arr[$l.'_close_hour']) ? $supporthours_arr[$l.'_close_hour'] : 'HH';
$day_close_min 	= isset($supporthours_arr[$l.'_close_min']) ? $supporthours_arr[$l.'_close_min'] : 'MM';
$day_close_ampm = isset($supporthours_arr[$l.'_close_ampm']) ? $supporthours_arr[$l.'_close_ampm'] : '';

// after break
$day_open_hour_after_break 	= isset($supporthours_arr_after_break[$l.'_open_hour']) ? $supporthours_arr_after_break[$l.'_open_hour'] : 'HH';
$day_open_min_after_break 	= isset($supporthours_arr_after_break[$l.'_open_min']) ? $supporthours_arr_after_break[$l.'_open_min'] : 'MM';
$day_open_ampm_after_break 	= isset($supporthours_arr_after_break[$l.'_open_ampm']) ? $supporthours_arr_after_break[$l.'_open_ampm'] : '';
$day_close_hour_after_break = isset($supporthours_arr_after_break[$l.'_close_hour']) ? $supporthours_arr_after_break[$l.'_close_hour'] : 'HH';
$day_close_min_after_break 	= isset($supporthours_arr_after_break[$l.'_close_min']) ? $supporthours_arr_after_break[$l.'_close_min'] : 'MM';
$day_close_ampm_after_break = isset($supporthours_arr_after_break[$l.'_close_ampm']) ? $supporthours_arr_after_break[$l.'_close_ampm'] : '';

// button styles

/* available */
$w357_available_btn_style = 'style="background-color: '.$available_btn_background_color.'; color: '.$available_btn_text_color.'; -webkit-border-radius: '.$available_btn_border_radius.'; -moz-border-radius: '.$available_btn_border_radius.'; border-radius: '.$available_btn_border_radius.';"';

/* offline */
$w357_offline_btn_style = 'style="background-color: '.$offline_btn_background_color.'; color: '.$offline_btn_text_color.'; -webkit-border-radius: '.$offline_btn_border_radius.'; -moz-border-radius: '.$offline_btn_border_radius.'; border-radius: '.$offline_btn_border_radius.';"';

// build values (before break)
$open_hour 	= ($day_open_hour != 'HH' && $active_day == 'on') ? $day_open_hour : $default_open_hour;
$open_min 	= ($day_open_min != 'MM' && $active_day == 'on') ? $day_open_min : $default_open_min;
$open_ampm 	= (!empty($day_open_ampm) && $active_day == 'on') ? $day_open_ampm : $default_open_ampm;
$close_hour = ($day_close_hour != 'HH' && $active_day == 'on') ? $day_close_hour : $default_close_hour;
$close_min 	= ($day_close_min != 'MM' && $active_day == 'on') ? $day_close_min : $default_close_min;
$close_ampm = (!empty($day_close_ampm) && $active_day == 'on') ? $day_close_ampm : $default_close_ampm;

// build values (after break)
$open_hour_after_break 	= ($day_open_hour_after_break != 'HH' && $active_day == 'on') ? $day_open_hour_after_break : $default_open_hour_after_break;
$open_min_after_break 	= ($day_open_min_after_break != 'MM' && $active_day == 'on') ? $day_open_min_after_break : $default_open_min_after_break;
$open_ampm_after_break 	= (!empty($day_open_ampm_after_break) && $active_day == 'on') ? $day_open_ampm_after_break : $default_open_ampm_after_break;
$close_hour_after_break = ($day_close_hour_after_break != 'HH' && $active_day == 'on') ? $day_close_hour_after_break : $default_close_hour_after_break;
$close_min_after_break 	= ($day_close_min_after_break != 'MM' && $active_day == 'on') ? $day_close_min_after_break : $default_close_min_after_break;
$close_ampm_after_break = (!empty($day_close_ampm_after_break) && $active_day == 'on') ? $day_close_ampm_after_break : $default_close_ampm_after_break;

// Official Support Hour
if ($hour_system == '12'):

	// before break
	$datetime_open 	= date("g:i", strtotime($open_hour.":".$open_min." ".$open_ampm)).''.($hour_system == '12' ? ' '.$open_ampm : ''); // "13:30"
	$datetime_close = date("g:i", strtotime($close_hour.":".$close_min." ".$close_ampm)).''.($hour_system == '12' ? ' '.$close_ampm : ''); // "13:30"
	$open_hour 		= date("g", strtotime($open_hour.":".$open_min." ".$open_ampm));
	$close_hour 	= date("g", strtotime($close_hour.":".$close_min." ".$close_ampm));

	// after break
	$datetime_open_after_break 		= date("g:i", strtotime($open_hour_after_break.":".$open_min_after_break." ".$open_ampm_after_break)).''.($hour_system == '12' ? ' '.$open_ampm_after_break : ''); // "13:30"
	$datetime_close_after_break 	= date("g:i", strtotime($close_hour_after_break.":".$close_min_after_break." ".$close_ampm_after_break)).''.($hour_system == '12' ? ' '.$close_ampm_after_break : ''); // "13:30"
	$open_hour_after_break 			= date("g", strtotime($open_hour_after_break.":".$open_min_after_break." ".$open_ampm_after_break));
	$close_hour_after_break 		= date("g", strtotime($close_hour_after_break.":".$close_min_after_break." ".$close_ampm_after_break));

elseif ($hour_system == '24'):
	
	// before break
	$datetime_open 	= date("G:i", strtotime($open_hour.":".$open_min." ".$open_ampm)).''.($hour_system == '12' ? ' '.$open_ampm : ''); // "1:30 PM"
	$datetime_close = date("G:i", strtotime($close_hour.":".$close_min." ".$close_ampm)).''.($hour_system == '12' ? ' '.$close_ampm : ''); // "1:30 PM"
	$open_hour 		= date("G", strtotime($open_hour.":".$open_min." ".$open_ampm));
	$close_hour 	= date("G", strtotime($close_hour.":".$close_min." ".$close_ampm));

	// after break
	$datetime_open_after_break 	= date("G:i", strtotime($open_hour_after_break.":".$open_min_after_break." ".$open_ampm_after_break)).''.($hour_system == '12' ? ' '.$open_ampm_after_break : ''); // "1:30 PM"
	$datetime_close_after_break = date("G:i", strtotime($close_hour_after_break.":".$close_min_after_break." ".$close_ampm_after_break)).''.($hour_system == '12' ? ' '.$close_ampm_after_break : ''); // "1:30 PM"
	$open_hour_after_break 		= date("G", strtotime($open_hour_after_break.":".$open_min_after_break." ".$open_ampm_after_break));
	$close_hour_after_break 	= date("G", strtotime($close_hour_after_break.":".$close_min_after_break." ".$close_ampm_after_break));

endif;

// Check for holidays
$holiday_data = [];
foreach ($holidays as $holiday)
{
	$is_holiday = $modSupportHoursHelper->check_in_range($holiday->holiday_from, $holiday->holiday_to, date('Y-m-d', strtotime($our_date_value)));
	if ($is_holiday)
	{
		$holiday_data[] = [
			'holiday_name' => $holiday->holiday_name,
			'holiday_from' => $holiday->holiday_from,
			'holiday_to' => $holiday->holiday_to
		];
	}
}

if (!empty($holiday_data))
{
	$active_day = 'off';
	$holiday_front_text = $holiday_data[0]['holiday_name'];
}
else
{
	$holiday_front_text = '';
}

// Check if support is available or offline by our time and store's open/close datetime
$support_is_online_before_break = $modSupportHoursHelper->check_in_range($datetime_open, $datetime_close, $our_time_static);
$support_is_online_after_break 	= $modSupportHoursHelper->check_in_range($datetime_open_after_break, $datetime_close_after_break, $our_time_static);
$support_is_online 				= ($support_is_online_before_break || ($day_break && $support_is_online_after_break)) ? true : false;

// Get the online/offline text for each day
$day_name = strtolower($l);
$online_text = ${$day_name."_online_text"};
$offline_text = ${$day_name."_offline_text"};
$front_text_available = ${$day_name."_front_text_available"};
$front_text_offline = ${$day_name."_front_text_offline"};

// Support Status
if ($active_day == 'on' && $support_is_online):
	$support_status = '<div class="mod_sh_status_available">'.$online_text.'</div>';
else:
	$support_status = '<div class="mod_sh_status_offline">'.$offline_text.'</div>';
endif;

// Front Text
if ($active_day == 'on' && $support_is_online):
	$front_text = $front_text_available;
else:
	$front_text = $front_text_offline;
endif;

// Holiday Text
if (!empty($holiday_front_text)):
	$front_text = $holiday_front_text;
endif;

// Today Open/Close time
switch ($open_hours_time_format):
    case "full_with_pmam": // 09:00am - 05:00pm
        $today_open 				= $open_hour.':'.$open_min.''.$open_ampm;
        $today_close 				= $close_hour.':'.$close_min.''.$close_ampm;
		$today_open_after_break 	= $open_hour_after_break.':'.$open_min_after_break.''.$open_ampm_after_break;
        $today_close_after_break 	= $close_hour_after_break.':'.$close_min_after_break.''.$close_ampm_after_break;
        break;
    case "only_hours_with_pmam": // 09am - 05pm
        $today_open 				= $open_hour.''.$open_ampm;
        $today_close 				= $close_hour.''.$close_ampm;
		$today_open_after_break 	= $open_hour_after_break.''.$open_ampm_after_break;
        $today_close_after_break 	= $close_hour_after_break.''.$close_ampm_after_break;
        break;
    case "full_without_pmam": // 09:00 - 05:00
        $today_open 				= $open_hour.':'.$open_min;
        $today_close				= $close_hour.':'.$close_min;
		$today_open_after_break 	= $open_hour_after_break.':'.$open_min_after_break;
        $today_close_after_break 	= $close_hour_after_break.':'.$close_min_after_break;
        break;
    default:
		$today_open 				= $open_hour.':'.$open_min.''.$open_ampm;
        $today_close 				= $close_hour.':'.$close_min.''.$close_ampm;
		$today_open_after_break 	= $open_hour_after_break.':'.$open_min_after_break.''.$open_ampm_after_break;
        $today_close_after_break 	= $close_hour_after_break.':'.$close_min_after_break.''.$close_ampm_after_break;
endswitch;
// END: Open Hours

// Custom CSS Styling
if (!empty($custom_css_param)):
	$doc = JFactory::getDocument();
	$doc->addStyleDeclaration($custom_css_param);
endif;

// Output
echo '<div id="mod_supporthours">';
	
	if (!defined("DS")):
		define("DS", DIRECTORY_SEPARATOR);
	endif;
	$layout_file = JPATH_ROOT.DS.'modules'.DS.'mod_supporthours'.DS.'tmpl'.DS.$layout.'.php';
	if (file_exists($layout_file)):
		require(JModuleHelper::getLayoutPath('mod_supporthours', $layout));
	else:
		echo '<p>The <strong>'.$layout.'</strong> crashed or does not exist anymore. Please, contact Web357\'s support department.</p>';
	endif;
echo '</div>';